import { RequestInit, Response } from "node-fetch";
declare type Url<S extends string> = S extends `http${infer A}` ? S : never;
declare type IsUrl<S extends string> = Url<S> extends never ? false : true;
declare type Extname<S extends string> = S extends `${infer A}.${infer B}` ? B : never;
declare type HasExt<S extends string> = Extname<S> extends never ? false : true;
interface DirOptions {
    recursive?: boolean;
}
declare function fetch<T extends string, Opts = IsUrl<T> extends true ? RequestInit : HasExt<T> extends true ? never : DirOptions>(url: T, opts?: Opts): Promise<Response>;
export default fetch;
